/*
Master Device; PIC16F877A
Frequency; 8Mhz
Point to Note; The sending from the master and the receiving
from the slave must happen at the same time, if not, the simulation o
n proteus wount work. even a 10ms delay would cause it not to work. check out the
10ms delay commented out in the master code.
mail;oluwoleoyetoke@yahoo.com

 Toggle The Switch in the Circuit in Quick Succession, for it to Activate and Deactivate
 */



//LCD Connection
sbit LCD_EN at RD3_bit;
sbit LCD_RS at RD2_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D4 at RD4_bit;

sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_D7_Direction at TRISD7_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D4_Direction at TRISD4_bit;

//Soft SPI Connection
sbit SoftSpi_CLK at RC3_bit;
sbit SoftSpi_SDI at RC4_bit;
sbit SoftSpi_SDO at RC5_bit;


sbit SoftSpi_CLK_Direction at TRISC3_bit;
sbit SoftSpi_SDI_Direction at TRISC4_bit;
sbit SoftSpi_SDO_Direction at TRISC5_bit;

unsigned short data_read;

char data_send;
void main() {
       //TRISD=0;
       //PORTD=0;
       TRISD.B0=1;   //SPI Read activation condition
       PORTD.B0=0;    //Clear the pin
       TRISC.B3=1;     //Set CLK pin as input
       TRISC.B4=1;     //Set SDI pin as Input
       TRISC.B5=0;      //Set SDO pin as Output

         Lcd_Init();      //Initialize LCD

       Soft_SPI_Init();

    while(1)
    {
     if(PORTD.f0==1)             //Condition for Read Command activation
     {
       data_read = Soft_SPI_Read(data_send);
       Delay_ms(100);
  if((char)data_read == '1')
  {
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Out(1,1,"One");
  Delay_ms(1000);
  }
  else if ((char)data_read == '2')
  {
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Out(1,1,"Two");
  Delay_ms(1000);
  }
   else if ((char)data_read == '3')
  {
Lcd_Cmd(_LCD_CLEAR);
  Lcd_Out(1,1,"Three");
  Delay_ms(1000);
  }
   else if ((char)data_read == '4')
  {
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Out(1,1,"Four");
  Delay_ms(1000);
  }
   else if ((char)data_read == '5')
  {
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Out(1,1,"Five");
  Delay_ms(1000);
  }
   else if ((char)data_read == '6')
  {
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Out(1,1,"Six");
  Delay_ms(1000);
  }
   else if ((char)data_read == '7')
  {
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Out(1,1,"Seven");
  Delay_ms(1000);
  }
  }
}
}