/* 
Master Device; PIC16F877A
Frequency; 8Mhz
Point to Note; The sending from the master and the receiving 
from the slave must happen at the same time, if not, the simulation o
n proteus wount work. even a 10ms delay would cause it not to work. check out the
10ms delay commented out in the code below.
mail;oluwoleoyetoke@yahoo.com

 Toggle The Switch in the Circuit in Quick Succession, for it to Activate and Deactivate
 */




//Declaring Variables
char data_send;


//Soft Spi Pins
sbit SoftSpi_CLK at RC3_bit;
sbit SoftSpi_SDI at RC4_bit;
sbit SoftSpi_SDO at RC5_bit;


sbit SoftSpi_CLK_Direction at TRISC3_bit;
sbit SoftSpi_SDI_Direction at TRISC4_bit;
sbit SoftSpi_SDO_Direction at TRISC5_bit;



void main() {
TRISB.B1=1; //Spi Activate  pin set as input
PORTB.B1=0;  //clear pin
TRISC.B3=0;   //  CLK pin set as Output
TRISC.B4=1;    //SDI Pin set as input
TRISC.B5=0;     //SDO pin set as output


data_send='1';   //start send data from 1
     Soft_SPI_Init();

    while(1)
    {

          if(PORTB.f1==1)
          {
          //Delay_ms(10);
     Soft_SPI_Write(data_send);
     data_send++;      //Increase from 1 to 7
     
      if((char)data_send>='8')   //if the value gets to 8 start all over from 1 again
            {
             data_send='1';
             }
    Delay_ms(500);


              }
     }

}