
_main:

;SPI_Slave.c,43 :: 		void main() {
;SPI_Slave.c,46 :: 		TRISD.B0=1;   //SPI Read activation condition
	BSF        TRISD+0, 0
;SPI_Slave.c,47 :: 		PORTD.B0=0;    //Clear the pin
	BCF        PORTD+0, 0
;SPI_Slave.c,48 :: 		TRISC.B3=1;     //Set CLK pin as input
	BSF        TRISC+0, 3
;SPI_Slave.c,49 :: 		TRISC.B4=1;     //Set SDI pin as Input
	BSF        TRISC+0, 4
;SPI_Slave.c,50 :: 		TRISC.B5=0;      //Set SDO pin as Output
	BCF        TRISC+0, 5
;SPI_Slave.c,52 :: 		Lcd_Init();      //Initialize LCD
	CALL       _Lcd_Init+0
;SPI_Slave.c,54 :: 		Soft_SPI_Init();
	CALL       _Soft_SPI_Init+0
;SPI_Slave.c,56 :: 		while(1)
L_main0:
;SPI_Slave.c,58 :: 		if(PORTD.f0==1)             //Condition for Read Command activation
	BTFSS      PORTD+0, 0
	GOTO       L_main2
;SPI_Slave.c,60 :: 		data_read = Soft_SPI_Read(data_send);
	MOVF       _data_send+0, 0
	MOVWF      FARG_Soft_SPI_Read_sdata+0
	CALL       _Soft_SPI_Read+0
	MOVF       R0+0, 0
	MOVWF      _data_read+0
;SPI_Slave.c,61 :: 		Delay_ms(100);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L_main3:
	DECFSZ     R13+0, 1
	GOTO       L_main3
	DECFSZ     R12+0, 1
	GOTO       L_main3
	DECFSZ     R11+0, 1
	GOTO       L_main3
	NOP
;SPI_Slave.c,62 :: 		if((char)data_read == '1')
	MOVF       _data_read+0, 0
	XORLW      49
	BTFSS      STATUS+0, 2
	GOTO       L_main4
;SPI_Slave.c,64 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;SPI_Slave.c,65 :: 		Lcd_Out(1,1,"One");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr1_SPI_Slave+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;SPI_Slave.c,66 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main5:
	DECFSZ     R13+0, 1
	GOTO       L_main5
	DECFSZ     R12+0, 1
	GOTO       L_main5
	DECFSZ     R11+0, 1
	GOTO       L_main5
	NOP
	NOP
;SPI_Slave.c,67 :: 		}
	GOTO       L_main6
L_main4:
;SPI_Slave.c,68 :: 		else if ((char)data_read == '2')
	MOVF       _data_read+0, 0
	XORLW      50
	BTFSS      STATUS+0, 2
	GOTO       L_main7
;SPI_Slave.c,70 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;SPI_Slave.c,71 :: 		Lcd_Out(1,1,"Two");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr2_SPI_Slave+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;SPI_Slave.c,72 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main8:
	DECFSZ     R13+0, 1
	GOTO       L_main8
	DECFSZ     R12+0, 1
	GOTO       L_main8
	DECFSZ     R11+0, 1
	GOTO       L_main8
	NOP
	NOP
;SPI_Slave.c,73 :: 		}
	GOTO       L_main9
L_main7:
;SPI_Slave.c,74 :: 		else if ((char)data_read == '3')
	MOVF       _data_read+0, 0
	XORLW      51
	BTFSS      STATUS+0, 2
	GOTO       L_main10
;SPI_Slave.c,76 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;SPI_Slave.c,77 :: 		Lcd_Out(1,1,"Three");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr3_SPI_Slave+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;SPI_Slave.c,78 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main11:
	DECFSZ     R13+0, 1
	GOTO       L_main11
	DECFSZ     R12+0, 1
	GOTO       L_main11
	DECFSZ     R11+0, 1
	GOTO       L_main11
	NOP
	NOP
;SPI_Slave.c,79 :: 		}
	GOTO       L_main12
L_main10:
;SPI_Slave.c,80 :: 		else if ((char)data_read == '4')
	MOVF       _data_read+0, 0
	XORLW      52
	BTFSS      STATUS+0, 2
	GOTO       L_main13
;SPI_Slave.c,82 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;SPI_Slave.c,83 :: 		Lcd_Out(1,1,"Four");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr4_SPI_Slave+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;SPI_Slave.c,84 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main14:
	DECFSZ     R13+0, 1
	GOTO       L_main14
	DECFSZ     R12+0, 1
	GOTO       L_main14
	DECFSZ     R11+0, 1
	GOTO       L_main14
	NOP
	NOP
;SPI_Slave.c,85 :: 		}
	GOTO       L_main15
L_main13:
;SPI_Slave.c,86 :: 		else if ((char)data_read == '5')
	MOVF       _data_read+0, 0
	XORLW      53
	BTFSS      STATUS+0, 2
	GOTO       L_main16
;SPI_Slave.c,88 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;SPI_Slave.c,89 :: 		Lcd_Out(1,1,"Five");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr5_SPI_Slave+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;SPI_Slave.c,90 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main17:
	DECFSZ     R13+0, 1
	GOTO       L_main17
	DECFSZ     R12+0, 1
	GOTO       L_main17
	DECFSZ     R11+0, 1
	GOTO       L_main17
	NOP
	NOP
;SPI_Slave.c,91 :: 		}
	GOTO       L_main18
L_main16:
;SPI_Slave.c,92 :: 		else if ((char)data_read == '6')
	MOVF       _data_read+0, 0
	XORLW      54
	BTFSS      STATUS+0, 2
	GOTO       L_main19
;SPI_Slave.c,94 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;SPI_Slave.c,95 :: 		Lcd_Out(1,1,"Six");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr6_SPI_Slave+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;SPI_Slave.c,96 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main20:
	DECFSZ     R13+0, 1
	GOTO       L_main20
	DECFSZ     R12+0, 1
	GOTO       L_main20
	DECFSZ     R11+0, 1
	GOTO       L_main20
	NOP
	NOP
;SPI_Slave.c,97 :: 		}
	GOTO       L_main21
L_main19:
;SPI_Slave.c,98 :: 		else if ((char)data_read == '7')
	MOVF       _data_read+0, 0
	XORLW      55
	BTFSS      STATUS+0, 2
	GOTO       L_main22
;SPI_Slave.c,100 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;SPI_Slave.c,101 :: 		Lcd_Out(1,1,"Seven");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr7_SPI_Slave+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;SPI_Slave.c,102 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main23:
	DECFSZ     R13+0, 1
	GOTO       L_main23
	DECFSZ     R12+0, 1
	GOTO       L_main23
	DECFSZ     R11+0, 1
	GOTO       L_main23
	NOP
	NOP
;SPI_Slave.c,103 :: 		}
L_main22:
L_main21:
L_main18:
L_main15:
L_main12:
L_main9:
L_main6:
;SPI_Slave.c,104 :: 		}
L_main2:
;SPI_Slave.c,105 :: 		}
	GOTO       L_main0
;SPI_Slave.c,106 :: 		}
	GOTO       $+0
; end of _main
